####	DRIFT MENU SYSTEM
####	=================
####
####	by Sinanju
####
####	An Add-On for LFSLapper V5.926 and later
####	(but preferably v6.011)
####
####
####	Install this file into ..\bin\default\includes
####	then open the addonsused.lpr file and paste the following line (without hashes)
####	include( "./driftmenu.lpr");
####
#####################################################################################
# Ver 0.1 - 10 Feb 2012 - Mock Up / Proof of concept - will show top 200 drift scores
#####################################################################################

/*
To create colored text, use the following codes in front of the text you want to color:

^0 - black
^1 - red
^2 - green
^3 - yellow
^4 - blue
^5 - violet
^6 - cyan
^7 - white
^8 - no color
*/

##################################################
#	Set height of Top Drift menu when Lapper starts
##################################################

CatchEvent OnLapperStart()
	GlobalVar $DorigT; $DorigT = 164;	# Top edge of button - if you change this, then all buttons will keep in line - button originally set to 164 as keeps things beside the OK button for the table
EndCatchEvent


#####################################
#Action on teleport to pit (Shift+P)#
#####################################

# Actions to execute when player spectates or leaves race

CatchEvent OnLeaveRace( $userName )  # Player event
# This is so nothing visible when on track and will therefore not show mouse pointer on screen

	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*"); # closes all the buttons used for showing Drift Scores
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^3TOP ^2200 ^3DRIFT SCORES",DriftClick_Start ); # Takes you to start of sub-routines

EndCatchEvent


##########################
#	Main Group of Buttons >
##########################

Sub DriftClick_PreStart( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*"); # closes all the buttons used for showing Drift Scores
	closeDrf( );
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^3TOP ^2200 ^3DRIFT SCORES",DriftClick_Start ); # Takes you to start of sub-routines
EndSub

#########################################################
#	Sub-routines when any of main group of buttons clicked
#########################################################


Sub DriftClick_Start( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*"); # closes all the buttons used for showing Drift Scores
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D19 ); # Takes you to FORWARD sub-routine
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 ); # Takes you to LAST sub-routine
	drf ( 1 ); # Displays top 18 Drift Scores for ALL cars (if you only want specific cars, then look in your lfslapper.lpr file and amend the $DefaultTopCars list
EndSub


Sub DriftClick_D19( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );	
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D37 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 ); # Takes you to LAST sub-routine
	drf ( 19 ); 
EndSub

Sub DriftClick_D37( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D19 );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D55 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );
	drf ( 37 ); 
EndSub

Sub DriftClick_D55( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D37);	
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D73 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );	
	drf ( 55 ); 
EndSub
 
Sub DriftClick_D73( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D55 );	
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D91 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );	
	drf ( 73 ); 
EndSub

Sub DriftClick_D91( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D73 );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D109);
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );
	drf ( 91 ); 
EndSub

Sub DriftClick_D109( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D91 );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D127 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );
	drf ( 109 ); 
EndSub

Sub DriftClick_D127( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D109 );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D145 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );
	drf ( 127 ); 
EndSub

Sub DriftClick_D145( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D127 );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D163 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );
  drf ( 145 ); 
EndSub

Sub DriftClick_D163( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D145 );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D181 );
	openPrivButton( "dmenu_FAST_FORWARD_button",125,$DorigT,10,5,3,-1,16,"^7[ ^3>> ^7]",DriftClick_D199 );
	drf ( 163 ); 
EndSub

Sub DriftClick_D181( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D163 );
	openPrivButton( "dmenu_FORWARD_button",115,$DorigT,10,5,3,-1,16,"^7[ ^3> ^7]",DriftClick_D199 );
	drf ( 181 ); 
EndSub

Sub DriftClick_D199( $KeyFlags,$id )
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*");
	openPrivButton( "dmenu_TOP_button",85,$DorigT,30,5,3,-1,16,"^2TOP DRIFT SCORES ^8[^1X^8]",DriftClick_PreStart );
	openPrivButton( "dmenu_BACK2START_button",65,$DorigT,10,5,3,-1,16,"^7[ ^3<< ^7]",DriftClick_Start );
	openPrivButton( "dmenu_BACK_button",75,$DorigT,10,5,3,-1,16,"^7[ ^3< ^7]",DriftClick_D181 );
	drf ( 199 ); 
EndSub


#########################################
#New Player joining race or entering pits
#########################################

CatchEvent OnNewPlayerJoin( $userName )  # Player event
	closeButtonRegex (GetCurrentPlayerVar("UserName"), "dmenu_*"); # closes all the buttons used for showing Drift Scores
	closeDrf( ); # close drift table in case its left open when re-joining track
EndCatchEvent